import { InstancesStore } from '@angular-three/core';
import { Directive, Input, SkipSelf } from '@angular/core';
export class ThreeBufferGeometry {
    constructor(instancesStore) {
        this.instancesStore = instancesStore;
        this._extraArgs = [];
    }
    set extraArgs(v) {
        this._extraArgs = v;
    }
    ngOnInit() {
        this._bufferGeometry = new this.geometryType(...this._extraArgs);
        this.instancesStore.saveBufferGeometry({
            id: this.ngtId,
            bufferGeometry: this._bufferGeometry,
        });
    }
    get bufferGeometry() {
        return this._bufferGeometry;
    }
    ngOnDestroy() {
        if (this.bufferGeometry) {
            this.instancesStore.removeBufferGeometry(this.ngtId || this.bufferGeometry.uuid);
        }
    }
}
ThreeBufferGeometry.decorators = [
    { type: Directive }
];
ThreeBufferGeometry.ctorParameters = () => [
    { type: InstancesStore, decorators: [{ type: SkipSelf }] }
];
ThreeBufferGeometry.propDecorators = {
    ngtId: [{ type: Input }]
};
//# sourceMappingURL=geometry.abstract.js.map