import { AnyConstructor, InstancesStore } from '@angular-three/core';
import { OnDestroy, OnInit } from '@angular/core';
import type { BufferGeometry } from 'three';
export declare abstract class ThreeBufferGeometry<TGeometry extends BufferGeometry = BufferGeometry> implements OnInit, OnDestroy {
    protected readonly instancesStore: InstancesStore;
    ngtId?: string;
    constructor(instancesStore: InstancesStore);
    abstract geometryType: AnyConstructor<TGeometry>;
    private _extraArgs;
    protected set extraArgs(v: unknown[]);
    ngOnInit(): void;
    private _bufferGeometry;
    get bufferGeometry(): TGeometry;
    ngOnDestroy(): void;
}
